app/urls.py
from django.conf.urls import url, include
from . import views
# from dchq_deploy.views import taskstatus
from django.conf import settings

urlpatterns = [
    url(r'^$', views.DashboardPage.as_view(template_name='app/app_list.html'), name='dashboard'),
    url(r'^poll_state$', views.poll_state,name='poll_state'),
    url(r'^create/(?P<pk>[^/]+)?$', views.app_create, name='app_create'),
    url(r'^create/$', views.app_create, name='app_create'),
    url(r'^(?P<pk>\d+)/delete/$', views.app_delete, name='app_delete'),
    url(r'^info/id/(?:(?P<pk>[^/]+))?/$', views.app_detail, name='app_info_poll'),
    url(r'^check_app_detail/$', views.check_app_detail, name='check_app_detail')
]


if settings.DEBUG:
    import debug_toolbar

    urlpatterns += [
        url(r'^__debug__/', include(debug_toolbar.urls)),
    ]

cooke_dchq_project/users/urls.py
from django.conf.urls import url, include

from . import views

urlpatterns = [
    url(
        regex=r'^$',
        view=views.UserListView.as_view(),
        name='list'
    ),
    url(
        regex=r'^~redirect/$',
        view=views.UserRedirectView.as_view(),
        name='redirect'
    ),
    url(
        regex=r'^(?P<username>[\w.@+-]+)/$',
        view=views.UserDetailView.as_view(),
        name='detail'
    ),
    url(
        regex=r'^~update/$',
        view=views.UserUpdateView.as_view(),
        name='update'
    ),
]

app/models.py
# app/models.py

# from __future__ import absolute_import, unicode_literals
from django.db import models


# Create your models here.

# Create a new queryset for our Blueprint manager
class BlueprintQuerySet(models.QuerySet):
    def as_list(self):
        """
        Return a list of lists containing Blueprint attributes
        """
        # Use list comprehension to return a list of lists; create the inner
        # lists by calling Blueprint.as_list on each Blueprint instance
        return [blueprint.as_list() for blueprint in self]


# Create a new model manager for our Blueprint model
class BlueprintManager(models.Manager):
    # def get_queryset(self):
    #     # Replace the default queryset with our one which can generate lists
    #     return BlueprintQuerySet(self.model, using=self._db)

    # 2016-12-31 edit: changed create_from_list to return queryset
    def create_from_list(self, blueprints_list):
        """
        Creates Blueprint instances from a list of (name, uid) pairs

        Returns a queryset of Blueprint instances
        """
        # Empty array to keep track of blueprints
        blueprint_pks = []

        # Step through the list
        # At the same time unpack the inner list into two variables
        for name, uid, type, tags in blueprints_list:
            # "self" here is a reference to the BlueprintManager instance, ie
            # Blueprint.objects (we'll assign it further down).
            #
            # get_or_create returns the object and a boolean for whether it was
            # created or loaded. We'll identify it by the uid, and if it
            # doesn't exist we'll create it with the name from the list
            blueprint, created = self.get_or_create(
                uid=uid, defaults={'name': name, 'type': type, 'tags': tags}
            )

            if not created and blueprint.name != name:
                # It already existed - but with the wrong name. Update.
                blueprint.name = name
                blueprint.save()

            # Keep track of blueprints we created or loaded
            blueprint_pks.append(blueprint.pk)

        # 2016-12-31 edit: make this return a queryset instead of list
        # Turn our list of blueprints into a Blueprint queryset
        blueprints = self.filter(pk__in=blueprint_pks)
        return blueprints


# Rename the class to something shorter, and use singular names not plural.
# If you put this in an app called "dchq_server", and this will show in the
# admin as "Dchq server > Blueprints".
# Note that python style guide is CamelCase for class names, so if you want the
# full name, it should be "DchqServerBlueprint"
class Blueprint(models.Model):
    # These fields are properties of the Blueprint, so they don't really need
    # a "blueprint" prefix. If you do want a prefix though, follow python
    # standards and call them "blueprint_name" rather than "blueprintName" -
    # python style guide is snake_case for variables, attributes and methods.
    # See https://www.python.org/dev/peps/pep-0008/#descriptive-naming-styles
    name = models.CharField(max_length=255)
    uid = models.CharField(max_length=255, unique=True)
    type = models.CharField(max_length=255, default='')
    tags = models.CharField(max_length=255, null=True)
    visibility = models.CharField(max_length=255, null=True, default='')

    # Now instantiate our new manager to replace the default one
    # 2016-12-31 edit: changed this line so that the manager gets queryset methods
    objects = BlueprintManager.from_queryset(BlueprintQuerySet)()

    # Str must return a string, you can't return a list.
    # Use something meaningful to humans - this will show up all over the admin
    def __str__(self):
        return self.name
        # Alternatively you could show both fields with something like
        # return '{} ({})'.format(self.name, self.uid)

    # If you want to get back your data in its original format, create a
    # separate method
    def as_list(self):
        """
        Return a list of blueprint attributes
        """
        return [self.name, self.uid, self.type, self.tags, self.visibility]


class userApps(models.Model):
    APPuid = models.CharField(max_length=255)
    AppName = models.CharField(max_length=255)
    owner = models.CharField(max_length=255)
    blueprintUid = models.CharField(max_length=255)
    blueprintYAML = models.CharField(max_length=2048)
    tags = models.CharField(max_length=255, null=True)
    buildTime = models.DateTimeField(auto_now_add=True, null=True, blank=True)
    lastMod = models.DateTimeField(auto_now_add=True, null=True, blank=True)
    appStatus = models.CharField(max_length=255)
    appLocalFqdn = models.CharField(max_length=255)
    appFqdn = models.CharField(max_length=255)

    # def __str__(self):
    #     return [self.APPuid, self.owner, self.blueprintUid, self.tags, self.buildTime, self.lastMod]

    def __str__(self):
        return self.AppName

    def get_fields_and_values(self):
        return [(field, field.value_to_string(self)) for field in userApps._meta.fields]


class userCustomBlueprintTemplates(models.Model):
    templateName = models.CharField(max_length=255)
    templateVisibility = models.CharField(max_length=255, null=True, default='')
    templateYAML = models.TextField(max_length=2048)
    templateIcon = models.CharField(max_length=255, null=True, default='fa-user')

    def __str__(self):
        return self.templateName


class dchqConnection(models.Model):  # model - class    - table
    username = models.CharField(max_length=255, default='admin@dchq.io', blank=True,
                                null=True)  # field - instance - row
    password = models.CharField(max_length=255, default='admin123', blank=True, null=True)
    hostEndpoint = models.CharField(max_length=255, default='192.168.1.180', blank=True, null=True)

    def __str__(self):
        return '%s %s %s' % (self.username, self.password, self.hostEndpoint)  # update, this works better
        # return localize(self.username, self.password, self.hostEndpoint)  # this one causes an error

cooke_dchq_project/users/models.py
from django.contrib.auth.models import AbstractUser
from django.core.urlresolvers import reverse
from django.db import models
from django.utils.encoding import python_2_unicode_compatible
from django.utils.translation import ugettext_lazy as _


@python_2_unicode_compatible
class User(AbstractUser):

    # First Name and Last Name do not cover name patterns
    # around the globe.
    name = models.CharField(_('Name of User'), blank=True, max_length=255)

    def __str__(self):
        return self.username

    def get_absolute_url(self):
        return reverse('users:detail', kwargs={'username': self.username})

cooke_dchq_project/users/views.py
from django.core.urlresolvers import reverse
from django.views.generic import DetailView, ListView, RedirectView, UpdateView

from django.contrib.auth.mixins import LoginRequiredMixin

from .models import User


class UserDetailView(LoginRequiredMixin, DetailView):
    model = User
    # These next two lines tell the view to index lookups by username
    slug_field = 'username'
    slug_url_kwarg = 'username'


class UserRedirectView(LoginRequiredMixin, RedirectView):
    permanent = False

    def get_redirect_url(self):
        return reverse('users:detail',
                       kwargs={'username': self.request.user.username})


class UserUpdateView(LoginRequiredMixin, UpdateView):

    fields = ['name', ]

    # we already imported User in the view code above, remember?
    model = User

    # send the user back to their own page after a successful update
    def get_success_url(self):
        return reverse('users:detail',
                       kwargs={'username': self.request.user.username})

    def get_object(self):
        # Only get the User record for the user making the request
        return User.objects.get(username=self.request.user.username)


class UserListView(LoginRequiredMixin, ListView):
    model = User
    # These next two lines tell the view to index lookups by username
    slug_field = 'username'
    slug_url_kwarg = 'username'

cooke_dchq_project/templates/app/includes/header.html
{# header.html#}
{% load static %}
<nav class="navbar navbar-toggleable-md navbar-light bg-faded">
    <button class="navbar-toggler navbar-toggler-right" type="button" data-toggle="collapse" data-target="#navbarNav"
            aria-controls="navbarNav" aria-expanded="false" aria-label="Toggle navigation">
        <span class="navbar-toggler-icon"></span>
    </button>
    <a class="navbar-brand" href="#">
        <img src="{% static 'images/bootstrap-solid.svg' %}" width="30" height="30" class="d-inline-block align-top"
             alt="">
        Bootstrap
    </a>
    <div class="collapse navbar-collapse" id="navbarNav">
        <ul class="navbar-nav">
            <li class="nav-item active">
                <a class="nav-link" href="#">Home <span class="sr-only">(current)</span></a>
            </li>
            <li class="nav-item">
                <a class="nav-link" href="#">Features</a>
            </li>
            <li class="nav-item">
                <a class="nav-link" href="#">Pricing</a>
            </li>
            <li class="nav-item">
                <a class="nav-link disabled" href="#">Disabled</a>
            </li>
        </ul>
    </div>
    <ul class="nav justify-content-end">
        <li class="nav-item"><span class="nav-link">
    {% if request.user.first_name or request.user.last_name %}
        {{ request.user.first_name }} {{ request.user.last_name }}
    {% else %}
        {{ request.user.username }}
    {% endif %}
</span>
        </li>
        {% if request.user.is_authenticated %}
            <li class="nav-item">
            <span class="nav-link">{% if request.user.profile.account_verified %}
                <span class="badge badge-warning">verified</span>  {% else %}
                <span class="badge badge-warning"><i class="fa fa-frown-o"
                                                     aria-hidden="true"></i> unverified</span> {% endif %}</span>
            </li>
            <li class="nav-item">
                <a class="nav-link" href="/accounts/logout/" class="pull-right">Logout</a>
            </li>

        {% else %}
            <li class="nav-item">
                <a class="nav-link" href="/accounts/login/" class="pull-right">Login</a>
            </li>

        {% endif %}

        </li>
    </ul>

</nav>

cooke_dchq_project/templates/app/includes/partial_app_create.html
{% load widget_tweaks %}
{% load staticfiles i18n %}
<form name="app_create_form" method="post" action="{% url 'app_create' %}" class="js-app-create-form">
    {% csrf_token %}
    <div class="modal-header">
        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
            <span aria-hidden="true">&times;</span>
        </button>
        <h4 class="modal-title">Create a New App</h4>
    </div>
    <div class="modal-body">
        {% for field in form %}
            <div id="{{ field.label }}" class="form-group{% if field.errors %} has-error{% endif %}">
                <label for="{{ field.id_for_label }}">{{ field.label }}</label>
                {% render_field field class="form-control" %}
{#                {{ field.templateName|attr:'required:false' }}#}
                {{ field.templateName }}
                {% for error in field.errors %}
                    <p class="help-block">{{ error }}</p>
                {% endfor %}
            </div>
        {% endfor %}
    </div>
    <div class="modal-footer">
        <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
        <button type="submit" class="btn btn-primary">Create App</button>
    </div>
</form>

cooke_dchq_project/templates/app/includes/partial_app_delete.html
{% load widget_tweaks %}


<form method="post" action="{% url 'app_delete' userApps.id %}" class="js-app-delete-form">
  {% csrf_token %}
  <div class="modal-header">
    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
      <span aria-hidden="true">&times;</span>
    </button>
    <h4 class="modal-title">Confirm app deletion</h4>
  </div>
  <div class="modal-body">
    <p class="lead">Are you sure you want to delete the App <strong>{{ userApps.AppName }}</strong>?</p>
  </div>
  <div class="modal-footer">
    <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
    <button type="submit" class="btn btn-danger">Delete App</button>
  </div>
</form>

cooke_dchq_project/templates/app/includes/partial_app_list.html
{% if userapps_list %}
    {% for DashboardPage in userapps_list %}
        <tr>
            <td>{{ DashboardPage.AppName }}</td>
            <td><a id="appFqdnHttp_{{ DashboardPage.id }}" href="http://{{ DashboardPage.appFqdn }}"><span id="appFqdn_{{ DashboardPage.id }}">{{ DashboardPage.appFqdn }}</span></a></td>
            <td><span id="appStatus_{{ DashboardPage.id }}">{{ DashboardPage.appStatus }}</span></td>
            <td>{{ DashboardPage.owner }}</td>
            <td>
{#                <p><a class="btn btn-outline-primary btn-sm js-update-app-stats" href="#"#}
{#                      onclick="updateAppInfo({{ DashboardPage.id }})" role="button"><span#}
{#                        class="fa fa-refresh"></span> Refresh</a></p>#}

                                <button type="button"
                        class="btn btn-outline-primary btn-sm js-update-app-stats"
                        onclick="updateAppInfo({{ DashboardPage.id }})" >
                    <span class="fa fa-refresh"></span> Refresh
                </button>
            </td>
            {#                    <td>#}
            {#                        <p><a class="btn btn-danger btn-sm js-delete-app"#}
            {#                              href="{% url 'delete_app' pk=DashboardPage.id %}" role="button"><span#}
            {#                                class="fa fa-trash"></span> Delete</a></p>#}
            {#                    </td>#}


            <td>
{#                <p><a class="btn btn-danger btn-sm js-delete-app"#}
{#                      href="{% url 'app_delete' DashboardPage.id %}" role="button"><span#}
{#                        class="fa fa-trash"></span> Delete</a></p>#}

                <button type="button"
                        class="btn btn-danger btn-sm js-delete-app"
                        data-url="{% url 'app_delete' DashboardPage.id %}">
                    <span class="fa fa-trash"></span> Delete
                </button>
            </td>


        </tr>
    {% endfor %}
{% else %}
    <tr>
        <td colspan="7" class="text-center bg-warning">There are no apps in your library.</td>
    </tr>
{% endif %}